package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.OrderLogistics;
import com.izouma.awesomeadmin.service.OrderLogisticsService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/orderLogistics")
@RequiresAuthentication
public class OrderLogisticsController {

    @Autowired
    private OrderLogisticsService orderLogisticsService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(OrderLogistics record) {
        List<OrderLogistics> pp = orderLogisticsService.getOrderLogisticsList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getOrderLogistics", method = RequestMethod.GET)
    @ResponseBody
    public Result getOrderLogistics(@RequestParam(required = false, value = "id") String id) {
        OrderLogistics data = orderLogisticsService.getOrderLogisticsById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(OrderLogistics record) {
        OrderLogistics data = orderLogisticsService.getOrderLogistics(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, OrderLogistics record) {
        Map<String, Object> result = new HashMap<>();

        List<OrderLogistics> pp =orderLogisticsService.getOrderLogisticsByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(OrderLogistics record) {
        boolean num = orderLogisticsService.createOrderLogistics(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateOrderLogistics(OrderLogistics record) {
        boolean num = orderLogisticsService.updateOrderLogistics(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteOrderLogistics(@RequestParam(required = true, value = "id") String id) {

        boolean num = orderLogisticsService.deleteOrderLogistics(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, OrderLogistics record) throws Exception {

    List<OrderLogistics> orderLogisticss = orderLogisticsService.getOrderLogisticsList(record);


        String sheetName = "order_logistics";
        String titleName = "订单物流数据表";
        String fileName = "订单物流表";
        int columnNumber = 12;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "订单" ,   "用户" ,   "物流公司" ,   "快递单号" ,   "类型" ,   "备注"  };
        String[][] dataList = new String[orderLogisticss.size()][12];

        for (int i = 0; i < orderLogisticss.size(); i++) {

                        dataList[i][0] = String.valueOf(orderLogisticss.get(i).getId());
                        dataList[i][1] = String.valueOf(orderLogisticss.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(orderLogisticss.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(orderLogisticss.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(orderLogisticss.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(orderLogisticss.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(orderLogisticss.get(i).getOrderId());
                        dataList[i][7] = String.valueOf(orderLogisticss.get(i).getUserId());
                        dataList[i][8] = String.valueOf(orderLogisticss.get(i).getLogistic());
                        dataList[i][9] = String.valueOf(orderLogisticss.get(i).getTrackingNo());
                        dataList[i][10] = String.valueOf(orderLogisticss.get(i).getTypeFlag());
                        dataList[i][11] = String.valueOf(orderLogisticss.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

